<?php

use EuKit\Base\Parts\NewsMLArticle;
use EuKit\Base\ViewModels\Teaser;
use Infomaker\Everyware\Base\OpenContent\OpenContentProvider;
use OcAPI as ocapi_clause;
use Infomaker\Imengine\Imengine;
use EuKit\Base\Parts\SimpleImage;


function returnFullArticleLists($query, $count, $start, $contenttypes)
{
    $articles = OpenContentProvider::setup([
        'q'                      => $query,
        'contenttypes'           => [$contenttypes],
        'sort.indexfield'        => 'Pubdate',
        'sort.Pubdate.ascending' => true,
        'filters'               => "Articles(start=".$start."|limit=".$count."|q=Published:true)",
    ]);


    $articles->setPropertyMap('Article');
      
    $oc_connection_url = new ocapi_clause();
    $articlesData = array_map(function (NewsMLArticle $article) use($oc_connection_url) {
        $teaser = new Teaser($article);
        $teaserView = $teaser->getViewData();
        $counter = 0;
        foreach($teaserView['relatedArticles'] as $relatedArticles){
            $sReasultArr = $oc_connection_url->get_single_article(
                $relatedArticles["uuid"]
            );

            $size = 700;
            $thumbnail = new SimpleImage([
                'src' => Imengine::create()->fit($size)->fromUuid($sReasultArr['article']['prop_data']["teaserimageuuids"][0]),
                'width' => $size,
                'height' => $size,
            ]);
           
            
            $teaserView['relatedArticles'][$counter]['image'] = $thumbnail;
            $teaserView['relatedArticles'][$counter]['authorName']  = $sReasultArr['article']['prop_data']["customerauthors"][0];
            $teaserView['relatedArticles'][$counter]['pubdate']  =  humanTimeDiff($sReasultArr['article']['prop_data']['pubdate'][0]);

            ++$counter;
        }
        return $teaserView;
    }, $articles->queryWithRequirements());
    //echo "<pre>"; print_r($articlesData); die;
    return [
        'articles' => $articlesData[0]["relatedArticles"],
        'hits' => $articles->hits()
    ];
}
